<template>
  <div class="registration-page">
    <div class="container">
      <div class="margin-top-50 content-block">
        <message v-show="$user.regStep < 4"></message>

        <bread-crumbs v-if="!$user.autologin"></bread-crumbs>
        <progress-bar v-if="!$user.autologin"></progress-bar>
        <keep-alive>
          <transition name="slide-fade">
            <component :is="currentComponent" @errorResponse="checkCodeError"/>
          </transition>
        </keep-alive>

        <!--@before-close="beforeClose"-->
        <!--@before-open="beforeOpen"-->
        <modal ref="resendCodeModal"
               name="resend-code"
               class="arcticmodal-container full-viewport"
               width="600"
               height="auto"
               :adaptive=true
               @before-close="!isSuccessResendSmsCode && $event.stop()"
        >
          <loader ref="loader"
                  v-bind="{
                      name: 'resendSmsModal',
                      isShow: isShowResendSmsCodeModalLoader,
                      waitingTitle: 'Восстановление сессии',
                      caption: '',
                  }"
          />
          <!--@change="handleSms"-->
          <!--@resend="againSms"-->
          <sms-form v-model="$user.smsCode"
                    :timeOut="60"
                    ref="smsForm"
                    class="sms-form"
          >
            <template slot="title">Время сессии истекло</template>
            <template slot="'additional-title'">
              Вам необходимо подтвердить свой номер телефона снова.
            </template>
            <template slot="agreement">
              <div class="sms-form__send-button-row">
                <button class="sms-form__send-button" @click="sendDataOfUser">Отправить</button>
              </div>
            </template>
          </sms-form>

        </modal>
      </div>
    </div>
  </div>
</template>

<script>
  import FirstPage from './FirstPage'
  import SecondPage from './SecondPage'
  import ThirdPage from './ThirdPage'
  import FourthPage from './FourthPage'
  import BreadCrumbs from './Common/BreadCrumbs'
  import ProgressBar from './Common/ProgressBar'
  import message from './message'
  import SmsForm from '@/components/SmsForm'
  import Loader from '@/components/Loader'

  import ErrorLog from '@/mixins/ErrorLog.js'
  import UserRegisterSms from '@/mixins/User/UserRegisterSms'

  export default {
    name: 'registration-index',
    components: {
      first: FirstPage,
      second: SecondPage,
      third: ThirdPage,
      fourth: FourthPage,
      BreadCrumbs,
      ProgressBar,
      message,
      SmsForm,
      Loader,
    },
    mixins: [
		ErrorLog,
        UserRegisterSms,
    ],
    data() {
      return {
        bodyClassName: 'lg-bg',
        componentsList: {
          1: 'first',
          2: 'second',
          3: 'third',
          4: 'fourth'
        },
        isShowResendSmsCodeModalLoader: false,
        isSuccessResendSmsCode: false,
	  	isResendCodeModal: true,
      };
    },
    computed: {
      currentComponent () {
        return this.componentsList[this.$user.regStep]
      }
    },
    watch: {
      /**
       * При изменении объекта user меняем время последнего действия на странице регистрации
       * По истечении 12 часов объект на странице должен сбратываться автоматически.
       */
      $user: {
        deep: true,
        handler () {
          this.$user.lastLoginTimeOnTheRegistrationPage = Date.now();
        }
      }
    },
      methods: {
		  async checkCodeError(error) {
		    console.warn(error.errors);
			  const errors = error.errors;
			  if(!Array.isArray(errors)) {
				  return;
			  }
			  for(const errorObject of errors) {
			  	  /*если ошибка имеет код 'mobilePhoneDoNotHaveActiveSmsCode'*/
				  if(errorObject.code === 'mobilePhoneDoNotHaveActiveSmsCode') {
					  await this.againSms();
					  this.$modal.show('resend-code');
					  break;
				  }
			  }
		  },
		  async resendUserData() {
			  this.isShowResendSmsCodeModalLoader = true;
			  await this.$store.dispatch('CREATE_USER', [
				  'lastName',
				  'firstName',
				  'middleName',
				  'mobilePhone',
				  'email',
				  'smsCode'
			  ])
				  .then(() => {
					  this.isSuccessResendSmsCode = true;
					  this.$modal.hide('resend-code');
				  })
				  .catch(error => {
				  	console.log(error);
				  })
			      this.isShowResendSmsCodeModalLoader = false;
          },
      },
    created () {

      /**
       * Сброс user, если прошел таймоут 12 часов с момента последней попытки регистрации.
       */
      const now = Date.now();
      // Date.now includes milliseconds
      if ((this.$user.lastLoginTimeOnTheRegistrationPage + 3600000 * 12) < now) {
        this.$store.commit('USER_RESET');
        this.$user.lastLoginTimeOnTheRegistrationPage = now;
      }

      if (this.$route.query.step && this.$user.login && this.$user.autologin) {
        this.$user.regStep = 4;
      } else if (this.$auth.isAuth && this.$user.regStep !== 4) {
        this.$router.push({name: 'my-loan'});
      } else {
        if (!this.$user.hash)
          this.$store.commit('SET_USER_HASH');
      }

      // this.$store.dispatch('lastLoginTimeOnTheRegistrationPageAndClearVuex')

    },
    mounted () {
      // if (this.$user.lastLoginTimeOnTheRegistrationPage === null) {
      //   this.$store.commit('USER_RESET')
      //   this.$user.lastLoginTimeOnTheRegistrationPage = Date.now()
      // }
    }
  }
</script>

<style scoped lang="scss">
  .sms-form {
    border: none;
    margin-bottom: 0;
  }
  .sms-form__send-button-row {
    display: flex;
    justify-content: center;
  }
  .sms-form__send-button {
    margin-bottom: 0;
  }
  .slide-fade-enter-active {
    transition: all .3s ease;
  }

  .slide-fade-leave-active {
    transition: all .3s ease;
  }

  .slide-fade-enter, .slide-fade-leave-to {
    transform: translateY(10px);
    opacity: 0;
  }

  .slide-fade-leave-to {
    transform: translateY(10px);
    opacity: 0;
  }
</style>
